VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCommonDialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' comDlg.cls (clsCommonFileDialog)
'     A wrapper class to implement the Windows Save File dialog.
'
'     Based on code by Steve Kirk in "A Visual Basic Class Wrapper for Common
' Dialog Functions" from MSDN:techart.chm::/html/msdn_comdlg.htm

Option Explicit

'API function called by ShowOpen method
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OpenFilename) As Long

'API function called by ShowSave method
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OpenFilename) As Long

'API function to retrieve extended error information
Private Declare Function CommDlgExtendedError Lib "comdlg32.dll" () As Long


'constants for file dialog
Private Const CDERR_DIALOGFAILURE = &HFFFF

Private Const CDERR_GENERALCODES = &H0
Private Const CDERR_STRUCTSIZE = &H1
Private Const CDERR_INITIALIZATION = &H2
Private Const CDERR_NOTEMPLATE = &H3
Private Const CDERR_NOHINSTANCE = &H4
Private Const CDERR_LOADSTRFAILURE = &H5
Private Const CDERR_FINDRESFAILURE = &H6
Private Const CDERR_LOADRESFAILURE = &H7
Private Const CDERR_LOCKRESFAILURE = &H8
Private Const CDERR_MEMALLOCFAILURE = &H9
Private Const CDERR_MEMLOCKFAILURE = &HA
Private Const CDERR_NOHOOK = &HB
Private Const CDERR_REGISTERMSGFAIL = &HC

Private Const FNERR_FILENAMECODES = &H3000
Private Const FNERR_SUBCLASSFAILURE = &H3001
Private Const FNERR_INVALIDFILENAME = &H3002
Private Const FNERR_BUFFERTOOSMALL = &H3003

'data buffer for the GetOpenFileName and GetSaveFileName functions
Private Type OpenFilename
        lStructSize As Long
        hwndOwner As Long
        hInstance As Long
        lpstrFilter As String
        lpstrCustomFilter As String
        nMaxCustFilter As Long
        iFilterIndex As Long
        lpstrFile As String
        nMaxFile As Long
        lpstrFileTitle As String
        nMaxFileTitle As Long
        lpstrInitialDir As String
        lpstrTitle As String
        flags As Long
        nFileOffset As Integer
        nFileExtension As Integer
        lpstrDefExt As String
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type

'internal property buffers
Private bCancelError As Boolean    'internal buffer for CancelError property
Private sDefaultExt As String      'internal buffer for sDefaultExt property
Private sDialogTitle As String     'internal buffer for DialogTitle property
Private sFileName As String        'internal buffer for FileName property
Private sFileTitle As String       'internal buffer for FileTitle property
Private sFilter As String          'internal buffer for Filter property
Private iFilterIndex As Integer    'internal buffer for FilterIndex property
Private lFlags As Long             'internal buffer for Flags property
Private lhdc As Long               'internal buffer for hdc property
Private sInitDir As String         'internal buffer for InitDir property
Private lMaxFileSize As Long       'internal buffer for MaxFileSize property

Private lApiReturn As Long         'internal buffer for APIReturn property
Private lExtendedError As Long     'internal buffer for ExtendedError property
Private sExtendedError As String   'internal buffer for ExtendedError string property

Public Sub ShowOpen()
    'display the file open dialog box
    ShowFileDialog (1)  'Action property - ShowOpen
End Sub

Public Sub ShowSave()
    'display the file save dialog box
    ShowFileDialog (2)  'Action property - ShowSave
End Sub

Public Property Get FileName() As String
    'return object's FileName property
    FileName = sFileName
End Property

Public Property Let FileName(vNewValue As String)
    'assign object's FileName property
    sFileName = vNewValue
End Property

Public Property Get Filter() As String
    'return object's Filter property
    Filter = sFilter
End Property

Public Property Let Filter(vNewValue As String)
    'assign object's Filter property
    sFilter = vNewValue
End Property

Public Property Get FilterIndex() As Integer
    'return object's FilterIndex property
    FilterIndex = iFilterIndex
End Property

Public Property Let FilterIndex(vNewValue As Integer)
    iFilterIndex = vNewValue
End Property

Public Property Get CancelError() As Boolean
    'Return object's CancelError property
    CancelError = bCancelError
End Property

Public Property Let CancelError(vNewValue As Boolean)
    'Assign object's CancelError property
    bCancelError = vNewValue
End Property

Public Property Get DefaultExt() As String
    'return object's DefaultExt property
    DefaultExt = sDefaultExt
End Property

Public Property Let DefaultExt(vNewValue As String)
    'assign object's DefaultExt property
    sDefaultExt = vNewValue
End Property

Public Property Get DialogTitle() As String
    'return object's FileName property
    DialogTitle = sDialogTitle
End Property

Public Property Let DialogTitle(vNewValue As String)
    'assign object's DialogTitle property
    sDialogTitle = vNewValue
End Property

Public Property Get flags() As Long
    'return object's Flags property
    flags = lFlags
End Property

Public Property Let flags(vNewValue As Long)
    'assign object's Flags property
    lFlags = vNewValue
End Property

Public Property Get hdc() As Long
    'Return object's hDC property
    hdc = lhdc
End Property

Public Property Let hdc(vNewValue As Long)
    'Assign object's hDC property
    lhdc = vNewValue
End Property

Public Property Get InitDir() As String
    'Return object's InitDir property
    InitDir = sInitDir
End Property

Public Property Let InitDir(vNewValue As String)
    'Assign object's InitDir property
    sInitDir = vNewValue
End Property

Public Property Get MaxFileSize() As Long
    'Return object's MaxFileSize property
    MaxFileSize = lMaxFileSize
End Property

Public Property Let MaxFileSize(vNewValue As Long)
    'Assign object's MaxFileSize property
    lMaxFileSize = vNewValue
End Property

' Read Only properties

Public Property Get FileTitle() As String
    'return object's FileTitle property
    FileTitle = sFileTitle
End Property

Public Property Get APIReturn() As Long
    'return object's APIReturn property
    APIReturn = lApiReturn
End Property

Public Property Get ExtendedError() As Long
    'return object's ExtendedError property
    ExtendedError = lExtendedError
End Property

Public Property Get ExtendedErrorStr() As String
    Select Case lExtendedError
        Case &H0
            ExtendedErrorStr = "No Error"
        Case &H1
            ExtendedErrorStr = "CDERR_STRUCTSIZE"
        Case &H2
            ExtendedErrorStr = "CDERR_INITIALIZATION"
        Case &H3
            ExtendedErrorStr = "CDERR_NOTEMPLATE"
        Case &H4
            ExtendedErrorStr = "CDERR_NOHINSTANCE"
        Case &H5
            ExtendedErrorStr = "CDERR_LOADSTRFAILURE"
        Case &H6
            ExtendedErrorStr = "CDERR_FINDRESFAILURE"
        Case &H7
            ExtendedErrorStr = "CDERR_LOADRESFAILURE"
        Case &H8
            ExtendedErrorStr = "CDERR_LOCKRESFAILURE"
        Case &H9
            ExtendedErrorStr = "CDERR_MEMALLOCFAILURE"
        Case &HA
            ExtendedErrorStr = "CDERR_MEMLOCKFAILURE"
        Case &HB
            ExtendedErrorStr = "CDERR_NOHOOK"
        Case &HC
            ExtendedErrorStr = "CDERR_REGISTERMSGFAIL"
        Case &H3000
            ExtendedErrorStr = "FNERR_FILENAMECODES"
        Case &H3001
            ExtendedErrorStr = "FNERR_SUBCLASSFAILURE"
        Case &H3002
            ExtendedErrorStr = "FNERR_INVALIDFILENAME"
        Case &H3003
            ExtendedErrorStr = "FNERR_BUFFERTOOSMALL"
        Case &HFFFF
            ExtendedErrorStr = "CDERR_DIALOGFAILURE"
        Case Else
            ExtendedErrorStr = "Unknown"
    End Select
End Property

Private Function sLeftOfNull(ByVal sIn As String)
    'returns the part of sIn preceding Chr$(0)
    Dim lNullPos As Long
    
    'init output
    sLeftOfNull = sIn
    
    'get position of first Chr$(0) in sIn
    lNullPos = InStr(sIn, Chr$(0))
    
    'return part of sIn to left of first Chr$(0) if found
    If lNullPos > 0 Then
        sLeftOfNull = Mid$(sIn, 1, lNullPos - 1)
    End If
End Function

Private Function sAPIFilter(sIn)
    'prepares sIn for use as a filter string in API common dialog functions
    Dim sOutStr As String
    
    sOutStr = sIn
    sOutStr = Replace(sOutStr, "|", Chr$(0))
    sOutStr = Replace(sOutStr, vbCrLf, Chr$(0))
    
    'add two nulls to the end
    sOutStr = sOutStr & Chr$(0)
    sOutStr = sOutStr & Chr$(0)
    
    'return sOutStr
    sAPIFilter = sOutStr
End Function

Private Function sByteArrayToString(abBytes() As Byte) As String
    'return a string from a byte array
    Dim lBytePoint As Long
    Dim lByteVal As Long
    Dim sOut As String
    
    'init array pointer
    lBytePoint = LBound(abBytes)
    
    'fill sOut with characters in array
    While lBytePoint <= UBound(abBytes)
        
        lByteVal = abBytes(lBytePoint)
        
        'return sOut and stop if Chr$(0) is encountered
        If lByteVal = 0 Then
            sByteArrayToString = sOut
            Exit Function
        Else
            sOut = sOut & Chr$(lByteVal)
        End If
        
        lBytePoint = lBytePoint + 1
    
    Wend
    
    'return sOut if Chr$(0) wasn't encountered
    sByteArrayToString = sOut
    
End Function

Private Sub ShowFileDialog(ByVal iAction As Integer)
    'display the file dialog for ShowOpen or ShowSave
    
    Dim tOpenFile As OpenFilename
    Dim spacesNeeded As Long
    
    On Error GoTo ShowFileDialogError
    
    '***    init property buffers
    lApiReturn = 0  'APIReturn property
    lExtendedError = 0  'ExtendedError property
    
    '***    prepare tOpenFile data
    'tOpenFile.lStructSize holds number of bytes of tOpenFile structure
    tOpenFile.lStructSize = Len(tOpenFile)
    
    'tOpenFile.hWndOwner As Long - init from hdc property
    tOpenFile.hwndOwner = lhdc
    
    'tOpenFile.lpstrFilter As String - init from Filter property
    tOpenFile.lpstrFilter = sAPIFilter(sFilter)
        
    'tOpenFile.iFilterIndex As Long - init from FilterIndex property
    tOpenFile.iFilterIndex = iFilterIndex
    
    'tOpenFile.lpstrFile As String
    'nMaxFile As Long - init from MaxFileSize property
    If lMaxFileSize <= 255 Then lMaxFileSize = 255
    tOpenFile.nMaxFile = lMaxFileSize
    
    'tOpenFile.lpstrFile As Long - init from FileName property
    'file name buffer must be as large as lMaxFileSize and null terminated
    spacesNeeded = lMaxFileSize - Len(sFileName) - 1
    If (spacesNeeded < 0) Then spacesNeeded = 0
    tOpenFile.lpstrFile = sFileName + Space(spacesNeeded) + Chr$(0)
            
    'lpstrFileTitle will hold the chosen file's name
    tOpenFile.nMaxFileTitle = lMaxFileSize
    tOpenFile.lpstrFileTitle = Space(lMaxFileSize - 1) + Chr$(0)
        
    'tOpenFile.lpstrInitialDir As String - init from InitDir property
    tOpenFile.lpstrInitialDir = sInitDir
    
    'tOpenFile.lpstrTitle As String - init from DialogTitle property
    tOpenFile.lpstrTitle = sDialogTitle
    
    'tOpenFile.flags As Long - init from Flags property
    tOpenFile.flags = lFlags
    
    'tOpenFile.lpstrDefExt As String - init from DefaultExt property
    tOpenFile.lpstrDefExt = sDefaultExt
    
    '***    call the GetOpenFileName API function
    Select Case iAction
        Case 1  'ShowOpen
            lApiReturn = GetOpenFileName(tOpenFile)
        Case 2  'ShowSave
            lApiReturn = GetSaveFileName(tOpenFile)
        Case Else   'unknown action
            Exit Sub
    End Select
    
    '***    handle return from GetOpenFileName API function
    Select Case lApiReturn
        Case 0  'user canceled or an error occured
            lExtendedError = CommDlgExtendedError   'call CommDlgExtendedError
            
            If bCancelError = True Then
                'generate an error
                err.Raise (2001)
                Exit Sub
            End If
        
        Case Else  'user selected or entered a file
            'sFileName gets part of tOpenFile.lpstrFile to the left of first Chr$(0)
            sFileName = sLeftOfNull(tOpenFile.lpstrFile)
            sFileTitle = sLeftOfNull(tOpenFile.lpstrFileTitle)
    End Select
Exit Sub

ShowFileDialogError:
    lApiReturn = -1
    Exit Sub
End Sub
