VERSION 5.00
Begin VB.Form frmWatcher 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "ReportsWatcher"
   ClientHeight    =   4965
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7980
   ForeColor       =   &H80000008&
   Icon            =   "watcher.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4965
   ScaleWidth      =   7980
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdOptions 
      Caption         =   "&Options..."
      Height          =   375
      Left            =   2303
      TabIndex        =   8
      Top             =   4500
      Width           =   1575
   End
   Begin VB.CommandButton cmdViewHTML 
      Caption         =   "&Edit HTML..."
      Height          =   375
      Left            =   4103
      TabIndex        =   9
      Top             =   4500
      Width           =   1575
   End
   Begin VB.Timer tmrWatcher 
      Interval        =   1000
      Left            =   3600
      Top             =   600
   End
   Begin VB.CommandButton cmdChooseDest 
      Caption         =   "&Save In..."
      Height          =   355
      Index           =   1
      Left            =   255
      TabIndex        =   4
      Top             =   3600
      Width           =   1200
   End
   Begin VB.Frame Frame1 
      Caption         =   "HTML Summaries"
      Height          =   975
      Index           =   1
      Left            =   135
      TabIndex        =   5
      Top             =   3360
      Width           =   7755
      Begin VB.Label lblDest 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   -1  'True
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H00FF0000&
         Height          =   705
         Left            =   1425
         MousePointer    =   99  'Custom
         TabIndex        =   7
         Top             =   210
         Width           =   6300
      End
   End
   Begin VB.CommandButton cmdChooseSrc 
      Caption         =   "&Reports..."
      Height          =   355
      Index           =   0
      Left            =   255
      TabIndex        =   2
      Top             =   2550
      Width           =   1200
   End
   Begin VB.Frame Status 
      Caption         =   "Status"
      Height          =   1815
      Left            =   135
      TabIndex        =   0
      Top             =   240
      Width           =   7755
      Begin VB.Label lblStatus 
         Caption         =   "Idle"
         Height          =   1440
         Left            =   180
         TabIndex        =   1
         Top             =   255
         Width           =   7500
         WordWrap        =   -1  'True
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Raw Backup Reports"
      Height          =   975
      Index           =   0
      Left            =   135
      TabIndex        =   3
      Top             =   2310
      Width           =   7755
      Begin VB.Label lblSrc 
         Height          =   705
         Left            =   1410
         TabIndex        =   6
         Top             =   195
         Width           =   6300
      End
   End
End
Attribute VB_Name = "frmWatcher"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' watcher.frm (frmWatcher)
'
'     Code for running the main ReportsWatcher window and saving the reports as
' html.
'
'     A timer object ("tmrWatcher") periodically calls CreateHTMLFiles to scan
' the source directory for all files ending in ".utx". For each exported backup
' report, four html files are generated and a summary of the report is added to
' the summary html.
'
' Functions in this form:
'
' Miscellaneous Utilities:
'     StartDoc
'     GetParent
'     GetFileName
'     GetDestParent
'     GetDestPath
'     GetSourcePath
'     CopyImages
'     Overdue
'     FormatDate
'     FormatKBytes
'     PinToScreen
'
' HTML creation utilities:
'     encodeURL
'     getRow
'     addTH
'     addTD
'     addNavLinks
'     toSum, toRep, toSuc, toErr, toNvr, toLog
'
' Assembling the report files:
'     outputHeadRep, outputHeadSuc, outputHeadErr, outputHeadNvr
'     outputLineRep, outputLineSuc, outputLineErr, outputLineNvr
'     outputFootRep, outputFootSuc, outputFootErr, outputFootNvr
'     processOneReport
'     summarizeOneReport
'     CreateHTMLFiles
'
' Functions for manipulating default and current global data:
'     GetOptionDefault
'     GetOptionData
'     GetHTMLDefault
'     GetHTMLData
'     InitDataFromForm
'     InitOptionsForm
'     InitHTMLForm
'     RevertForm
'     UseDefaultFromGen/Sum/Rep/Suc/Err/Nvr
'
' Form functions (implement buttons, load/unload form, run timer)
'     cmdOptions_Click
'     cmdViewHTML_Click
'     Form_Load
'     Form_Unload
'     lblDest_Click
'     cmdChooseDest_Click
'     cmdChooseSrc_Click
'     tmrWatcher_Timer
'
' Copyright 2011 Sonic Solutions. Portions Copyright 1989-2011 EMC Corporation.


Option Explicit

' Globals
Dim gLastMod As Date            ' keep track of when we last exported the reports
Dim gData As GlobalData         ' our shared global data between the forms

' Private external functions
Private Declare Function ShellExecute Lib "shell32.dll" Alias _
    "ShellExecuteA" (ByVal hwnd As Long, ByVal lpszOp As _
    String, ByVal lpszFile As String, ByVal lpszParams As String, _
    ByVal lpszDir As String, ByVal FsShowCmd As Long) As Long
    
Private Declare Function GetDesktopWindow Lib "user32" () As Long

' Private constants
Const kImpossibleDate = #1/1/1890#

Const repSuffix = ".htm"
Const sucSuffix = "_success.htm"
Const errSuffix = "_fail.htm"
Const nvrSuffix = "_never.htm"
Const logSuffix = "_log.htm"
Const kLogIcon = "<img src=""images/log.gif"" width=11 height=14 border=0 alt=""View Log"">"

Const SW_SHOWNORMAL = 1

Const SE_ERR_FNF = 2&
Const SE_ERR_PNF = 3&
Const SE_ERR_ACCESSDENIED = 5&
Const SE_ERR_OOM = 8&
Const SE_ERR_DLLNOTFOUND = 32&
Const SE_ERR_SHARE = 26&
Const SE_ERR_ASSOCINCOMPLETE = 27&
Const SE_ERR_DDETIMEOUT = 28&
Const SE_ERR_DDEFAIL = 29&
Const SE_ERR_DDEBUSY = 30&
Const SE_ERR_NOASSOC = 31&
Const ERROR_BAD_FORMAT = 11&
Const ChrSpace As String = " "
Const ChrQuote As String = """"



' StartDoc
'     A wrapper for ShellExecute to open a document. This has the same effect as
' double clicking on it in Windows.
'
Function StartDoc(DocName As String) As Long
    Dim Scr_hDC As Long
    Scr_hDC = GetDesktopWindow()
    StartDoc = ShellExecute(Scr_hDC, "Open", DocName, _
    "", "C:\", SW_SHOWNORMAL)
End Function

' GetParent
'     Return the path to a filespecs parent. This is just the substring before
' the last slash in the path.
'
Function GetParent(ByVal somePath As String) As String
    Dim pathDelim As String
    Dim items
    
    If InStr(somePath, "\") <> 0 Then
        pathDelim = "\"
    Else
        pathDelim = "/"
    End If
    items = Split(somePath, pathDelim, -1)
    ReDim Preserve items(UBound(items) - 1)
    GetParent = Join(items, pathDelim)
End Function

' GetFileName
'     Return the file name from a path. This is the substring following the
' last slash in the path.
'
Function GetFileName(ByVal somePath As String) As String
    Dim items
    
    If InStr(somePath, "\") <> 0 Then
        items = Split(somePath, "\", -1)
    Else
        items = Split(somePath, "/", -1)
    End If
    GetFileName = items(UBound(items))
End Function

' GetDestPath
'     Display a Save As dialog box and return a filename. If the user chooses
' Cancel, return an empty string.
'
Function GetDestPath(myTitle As String, FileName As Variant)
    Dim objFileDlg As New clsCommonDialog                   ' from the clsCommonDialog class module
    Dim destFileName As String
    
    On Error Resume Next
    objFileDlg.InitDir = GetParent(FileName)
    destFileName = GetFileName(FileName)
    If (destFileName = "") Then destFileName = "index.htm"
    objFileDlg.FileName = destFileName
    objFileDlg.DialogTitle = myTitle
    
    objFileDlg.Filter = kHtmlFilesStr + " (*.htm)|*.htm|"
    objFileDlg.DefaultExt = "htm"
    objFileDlg.flags = OFN_HIDEREADONLY
    
    objFileDlg.ShowSave
    
    If objFileDlg.APIReturn <> 0 Then
        GetDestPath = objFileDlg.FileName
        CopyImages GetParent(objFileDlg.FileName)
    Else
        GetDestPath = FileName
    End If
End Function

' GetDestParent
'     Return the path for the passed in summary html file's parent directory.
' Call getDestParent() with no parameter to get the default destination's parent.
' Attempt to create the file if it does not exist
'
Function GetDestParent(Optional oldDest As String) As String
    Dim fs, f, destFile
    
    If (oldDest = "") Then oldDest = gData.destPath
    GetDestParent = GetParent(oldDest)
    
    On Error GoTo USE_DEFAULT_DEST
    Set fs = CreateObject("Scripting.FileSystemObject")
    If Not fs.FileExists(gData.destPath) Then
        destFile = fs.CreateTextFile(gData.destPath)
        destFile.Close
    End If
    Set f = fs.GetFile(gData.destPath)
    GetDestParent = f.ParentFolder.Path & "\"
USE_DEFAULT_DEST:
    On Error GoTo 0
    Exit Function
End Function

' GetSourcePath
'     Display a Open dialog box and return a filename. If the user chooses
' Cancel, return an empty string.
'
Function GetSourcePath(myTitle As String, FileName As Variant)
    Dim objFileDlg As New clsCommonDialog                   ' from the clsCommonDialog class module
    On Error Resume Next
    objFileDlg.InitDir = FileName
    objFileDlg.FileName = ""
    objFileDlg.DialogTitle = myTitle
    objFileDlg.Filter = kReportFilesStr + " (*.utx)|*.utx|"
    objFileDlg.flags = OFN_HIDEREADONLY
    objFileDlg.ShowOpen
    
    If objFileDlg.APIReturn <> 0 Then
        GetSourcePath = GetParent(objFileDlg.FileName)
    Else
        GetSourcePath = FileName
    End If
End Function

' CopyImages
'     Copy the images folder and its gif files to the new destination path.
'
Sub CopyImages(directoryPath)
    Dim fs As FileSystemObject
    Dim origImagesFolder As Folder
    Dim origImagesStr As String
    Dim targetImagesStr As String
    Dim targPath As String
    Dim images As Files
    Dim gifFile As File
    
    On Error GoTo DONT_COPY_IMAGES
    Set fs = CreateObject("Scripting.FileSystemObject")
    origImagesStr = fs.BuildPath(fs.GetFolder(App.Path), "images")
    targetImagesStr = fs.BuildPath(directoryPath, "images")
    If Not fs.FolderExists(targetImagesStr) Then
        fs.CreateFolder targetImagesStr
    End If
    
    ' copy each .gif file to new location, skip any duplicates
    Set origImagesFolder = fs.GetFolder(origImagesStr)
    Set images = origImagesFolder.Files
    For Each gifFile In images
        If (Right(gifFile.Name, 4) = ".gif") Then
            targPath = fs.BuildPath(targetImagesStr, gifFile.Name)
            gifFile.Copy targPath, False
        End If
    Next gifFile
DONT_COPY_IMAGES:
    On Error GoTo 0
    Exit Sub
End Sub

' Overdue
'     Return true if the date lastMod is more than comparedTo (in hours) old.
'
Function Overdue(ByVal lastMod As Date, ByVal comparedTo As String) As Boolean
    Overdue = DateDiff("s", lastMod, Now) > Val(comparedTo) * 60 * 60
End Function

' FormatDate
'     Returns the passed in string if it is a date or today's date as a String
' in the short date format otherwise.
'
Function FormatDate(d) As String
On Error GoTo NULLDATE:
    Dim dt As Date
    dt = DateValue(d)
    FormatDate = FormatDateTime(d, vbShortDate)
    Exit Function
NULLDATE:
    FormatDate = FormatDateTime(Date, vbShortDate)
End Function

' FormatKBytes
'     Returns a string best representing the amount of data
'
Function FormatKBytes(kBytes) As String
    If (kBytes > 1048576) Then                    ' 1024 * 1024
        FormatKBytes = "" & FormatNumber(kBytes / 1048576, 1) & " GB"
    ElseIf (kBytes > 1024) Then
        FormatKBytes = "" & FormatNumber(kBytes / 1024, 1) & " MB"
    Else
        FormatKBytes = "" & kBytes & " KB"
    End If
End Function

' PinToRect
'     Pins point to be within target rectangle.
'
Private Function PinToRect(ByRef point As Coor, ByRef targRect As Rect) As Coor
    PinToRect.x = point.x
    PinToRect.y = point.y
    
    If (point.x < targRect.left) Then
        PinToRect.x = targRect.left
    ElseIf (point.x > targRect.left + targRect.width) Then
        PinToRect.x = targRect.left + targRect.width
    End If
    
    If (point.x < targRect.top) Then
        PinToRect.x = targRect.top
    ElseIf (point.y > targRect.top + targRect.height) Then
        PinToRect.y = targRect.top + targRect.height
    End If
End Function

'
' encodeURL
'     Return the path with spaces changed to underscores.
'
Function encodeURL(ByRef url As String) As String
    encodeURL = Replace(url, " ", "_")
End Function

'
' getRow
'     Return the row header tag for the specified row type.
'
Function getRow(ByVal which As Integer) As String
    If (which = 0) Then
        getRow = "<tr CLASS=""BR_HEAD"">" + vbCrLf
    ElseIf (which Mod 2 = 1) Then
        getRow = "<tr CLASS=""BR_ODD"">" + vbCrLf
    Else
        getRow = "<tr CLASS=""BR_EVEN"">" + vbCrLf
    End If
End Function

' addTH+-
'     Add the formatted column header tag to the passed in target text.
'
Sub addTH(targStr As String, txt As String, classType As String)
    targStr = targStr & "<th class=""" & classType & """>" & txt & "</th>" & vbCrLf
End Sub

' addTD
'     Add the formatted column tag to the passed in target text.
'
Sub addTD(targStr As String, txt As String, Optional classType As String = "")
    If (classType = "") Then
        targStr = targStr & "<td>" & txt & "</td>" & vbCrLf
    Else
        targStr = targStr & "<td class=""" & classType & """>" & txt & "</td>" & vbCrLf
    End If
End Sub

' toSum
'     Return the html anchor tag for linking to the summary html file.
' The title is used in some browsers for rollover help.
'
Function toSum(linkTxt As String, Optional titleTxt As String = "") As String
    If (titleTxt = "") Then
        toSum = "<a href=""" & encodeURL(GetFileName(gData.destPath)) & """>" & linkTxt & "</a>"
    Else
        toSum = "<a href=""" & encodeURL(GetFileName(gData.destPath)) & """ title=""" & titleTxt & """>" & linkTxt & "</a>"
    End If
End Function

' toRep
'     Return the html anchor tag for linking to the reports html file.
' The title is used in some browsers for rollover help.
'
Function toRep(serverName As String, linkTxt As String, Optional titleTxt As String = "")
    If (titleTxt = "") Then
        toRep = "<a href=""" & encodeURL(serverName & repSuffix) & """>" & linkTxt & "</a>"
    Else
        toRep = "<a href=""" & encodeURL(serverName & repSuffix) & """ title=""" & titleTxt & """>" & linkTxt & "</a>"
    End If
End Function

' toSuc
'     Return the html anchor tag for linking to the successful backups html file.
' The title is used in some browsers for rollover help.
'
Function toSuc(serverName As String, linkTxt As String, Optional titleTxt As String = "")
    If (titleTxt = "") Then
        toSuc = "<a href=""" & encodeURL(serverName & sucSuffix) & """>" & linkTxt & "</a>"
    Else
        toSuc = "<a href=""" & encodeURL(serverName & sucSuffix) & """ title=""" & titleTxt & """>" & linkTxt & "</a>"
    End If
End Function

' toErr
'     Return the html anchor tag for linking to the failed backups html file.
' The title is used in some browsers for rollover help.
'
Function toErr(serverName As String, linkTxt As String, Optional titleTxt As String = "")
    If (titleTxt = "") Then
        toErr = "<a href=""" & encodeURL(serverName & errSuffix) & """>" & linkTxt & "</a>"
    Else
        toErr = "<a href=""" & encodeURL(serverName & errSuffix) & """ title=""" & titleTxt & """>" & linkTxt & "</a>"
    End If
End Function

' toNvr
'     Return the html anchor tag for linking to the "Never" backups html file.
' The title is used in some browsers for rollover help.
'
Function toNvr(serverName As String, linkTxt As String, Optional titleTxt As String = "")
    If (titleTxt = "") Then
        toNvr = "<a href=""" & encodeURL(serverName & nvrSuffix) & """>" & linkTxt & "</a>"
    Else
        toNvr = "<a href=""" & encodeURL(serverName & nvrSuffix) & """ title=""" & titleTxt & """>" & linkTxt & "</a>"
    End If
End Function

' toLog
'     Return the html anchor tag for linking to the "Log" html file.
' The title is used in some browsers for rollover help.
'
Function toLog(serverName As String, linkTxt As String, Optional stampTag As String = "", Optional titleTxt As String = "")
    Dim st As String
    Dim tt As String
    
    st = stampTag
    tt = titleTxt
    If (st <> "") Then st = "#" & st
    If (tt <> "") Then tt = " title=""" & tt & """"
    toLog = "<a href=""" & encodeURL(serverName & logSuffix & st) & """" & tt & ">" & linkTxt & "</a>"
End Function

' addNavLinks
'     Add the navigation links to the passed in target text.
'
Sub addNavLinks(targStr As String, forPage As ReportTypes, serverName As String)
    Dim menuSep As String
    
    menuSep = " | "
    If (forPage = kSummary) Then
        targStr = targStr + kSummaryStr & menuSep & vbCrLf
    Else
        targStr = targStr + toSum(kSummaryStr) & menuSep & vbCrLf
    End If
    If (forPage = kReport) Then
        targStr = targStr + kAllBackupsStr & menuSep & vbCrLf
    Else
        targStr = targStr + toRep(serverName, kAllBackupsStr) & menuSep & vbCrLf
    End If
    If (forPage = kSuccess) Then
        targStr = targStr + kSuccessfulBackupsStr & menuSep & vbCrLf
    Else
        targStr = targStr + toSuc(serverName, kSuccessfulBackupsStr) & menuSep & vbCrLf
    End If
    If (forPage = kError) Then
        targStr = targStr + kFailedBackupsStr & menuSep & vbCrLf
    Else
        targStr = targStr + toErr(serverName, kFailedBackupsStr) & menuSep & vbCrLf
    End If
    If (forPage = kNever) Then
        targStr = targStr + kVolumesNeverBackedUpStr + menuSep & vbCrLf
    Else
        targStr = targStr + toNvr(serverName, kVolumesNeverBackedUpStr) & menuSep & vbCrLf
    End If
    If (forPage = kLog) Then
        targStr = targStr + kLogStr + menuSep & vbCrLf
    Else
        targStr = targStr + toLog(serverName, kLogStr) & menuSep & vbCrLf
    End If
End Sub

' outputHeadRep
'     Output begining of complete listings for a single backup report.
' This uses the user-specified header.
'
Sub outputHeadRep(serverName As String, fStream)
    Dim hTxt As String
    Dim parentFile As String
    parentFile = gData.destPath
    
    ' Replace all instances of %%serverName%% with the specific server name for
    ' this report. (From the file name of the exported report.)
    hTxt = Replace(gData.rep.head, "%%serverName%%", serverName, 1, -1, vbTextCompare)
    
    addNavLinks hTxt, kReport, serverName
    
    ' add the table and row tags
    hTxt = hTxt & "<table class=""BR"" width=""100%"">" & vbCrLf & getRow(0)
        
    ' add the table header row
    addTH hTxt, kBackupDateStr, "BR_BKUP_DATE"
    addTH hTxt, kMachineNameStr, "BR_MACHINE"
    addTH hTxt, kSourceNameStr, "BR_SOURCE"
    addTH hTxt, kBackupSetNameStr, "BR_BKUP_SET"
    addTH hTxt, kActionStr, "BR_BKUP_ACTION"
    addTH hTxt, kNonFatalErrorsStr, "BR_NUM_ERRORS"
    addTH hTxt, kFatalErrorStr, "BR_ERR_CODE"
    addTH hTxt, kErrorNameStr, "BR_ERR_NAME"
    addTH hTxt, kKBStoredStr, "BR_KB_STORED"
    addTH hTxt, kKBTransferredStr, "BR_KB_TRANSFERRED"
    addTH hTxt, kFilesCopiedStr, "BR_FILES_COPIED"
    addTH hTxt, kDurationStr, "BR_BKUP_DURATION"
    addTH hTxt, kScriptNameStr, "BR_SCRIPT_NAME"
    addTH hTxt, kScriptStartDateStr, "BR_SCRIPT_START_DATE"
    addTH hTxt, kScriptStartTimeStr, "BR_SCRIPT_START_TIME"
    addTH hTxt, kSubvolumeParentStr, "BR_SUBVOLUME_PARENT"
    
    hTxt = hTxt & "</tr>" & vbCrLf
    fStream.Write (hTxt)
End Sub

' outputHeadSuc
'     Output the successful backup reports header. This uses the user-specified
' header from the "Edit HTML..." form.
'
Sub outputHeadSuc(serverName As String, fStream)
    Dim hTxt As String
    Dim parentFile As String
    parentFile = gData.destPath
    
    ' Replace all instances of %%serverName%% with the specific server name for
    ' this report. (From the file name of the exported report.)
    hTxt = Replace(gData.suc.head, "%%serverName%%", serverName, 1, -1, vbTextCompare)
    
    addNavLinks hTxt, kSuccess, serverName
    
    ' add table and row header tags
    hTxt = hTxt & vbCrLf & "<table class=""BR"">" & vbCrLf & getRow(0)
        
    ' Add the table header row
    addTH hTxt, kBackupDateStr, "BR_BKUP_DATE"
    addTH hTxt, kBackupDescriptionStr, "BR_SUC_DESCRIPTION"
    
    hTxt = hTxt & "</tr>" & vbCrLf
    fStream.Write (hTxt)
End Sub

' outputHeadErr
'     Output the failed backup reports header. This uses the user-specified
' header from the "Edit HTML..." form.
'
Sub outputHeadErr(serverName As String, fStream)
    Dim hTxt As String
    Dim parentFile As String
    parentFile = gData.destPath
    
    ' Replace all instances of %%serverName%% with the specific server name for
    ' this report. (From the file name of the exported report.)
    hTxt = Replace(gData.err.head, "%%serverName%%", serverName, 1, -1, vbTextCompare)
    
    addNavLinks hTxt, kError, serverName
    
    ' add table and row header tags
    hTxt = hTxt & vbCrLf & "<table class=""BR"">" & vbCrLf & getRow(0)
            
    ' Add the table header row
    addTH hTxt, kBackupDateStr, "BR_BKUP_DATE"
    addTH hTxt, kErrorDescriptionStr, "BR_ERR_DESCRIPTION"
    
    hTxt = hTxt & "</tr>" & vbCrLf
    fStream.Write (hTxt)
End Sub

' outputHeadNvr
'     Output the reports header for volumes that have never been backed up. This
' uses the user-specified header from the "Edit HTML..." form.
'
Sub outputHeadNvr(serverName As String, fStream)
    Dim hTxt As String
    Dim parentFile As String
    parentFile = gData.destPath
    
    ' Replace all instances of %%serverName%% with the specific server name for
    ' this report. (From the file name of the exported report.)
    hTxt = Replace(gData.nvr.head, "%%serverName%%", serverName, 1, -1, vbTextCompare)
    
    addNavLinks hTxt, kNever, serverName
    
    ' add table and row header tags
    hTxt = hTxt & vbCrLf & "<table class=""BR"">" & vbCrLf & getRow(0)
            
    ' Add the table header row
    addTH hTxt, kVolumeStr, "BR_NEVER_BACKED_UP"
    
    hTxt = hTxt & "</tr>" & vbCrLf
    fStream.Write (hTxt)
End Sub


' outputLineRep
'     Output a row for a backup event to the open file, fStream
'
Sub outputLineRep(serverName As String, items() As String, fStream, dex)
    Dim hTxt As String
    Dim bd As String
    Dim ts As String
    Dim t As String
    
    bd = items(kBkupDate) & " " & items(kBkupTime)
    ts = FormatTimeStamp(CDate(bd))
    hTxt = getRow(dex)
    addTD hTxt, toLog(serverName, bd, ts, "View Log"), "BR_BKUP_DATE"
    addTD hTxt, items(kMachineName), "BR_MACHINE"
    addTD hTxt, items(kSourceName), "BR_SOURCE"
    addTD hTxt, items(kBkupSetName), "BR_BKUP_SET"
    addTD hTxt, items(kAction), "BR_BKUP_ACTION"
    t = items(kNonFatalErrs)
    If (t > 0) Then t = t & " " & kLogIcon
    addTD hTxt, toLog(serverName, t, ts, "View Log"), "BR_NUM_ERRORS"
    t = items(kFatalErr)
    If (t > 0) Then t = t & " " & kLogIcon
    addTD hTxt, toLog(serverName, t, ts, "View Log"), "BR_ERR_CODE"
    addTD hTxt, items(kErrName), "BR_ERR_NAME"
    addTD hTxt, items(kKBStored), "BR_KB_STORED"
    addTD hTxt, items(kKBTransferred), "BR_KB_TRANSFERRED"
    addTD hTxt, items(kNumFilesCopied), "BR_FILES_COPIED"
    addTD hTxt, items(kDuration), "BR_BKUP_DURATION"
    addTD hTxt, items(kScriptName), "BR_SCRIPT_NAME"
    addTD hTxt, items(kScriptStartDate), "BR_SCRIPT_START_DATE"
    addTD hTxt, items(kScriptStartTime), "BR_SCRIPT_START_TIME"
    If (UBound(items) > kMaxColumns) Then
        addTD hTxt, items(kMacSubVolParent), "BR_SUBVOLUME_PARENT"
    Else
        addTD hTxt, items(kSubVolParent), "BR_SUBVOLUME_PARENT"
    End If
    
    hTxt = hTxt & "</tr>" & vbCrLf
    fStream.Write (hTxt)
End Sub

' outputLineSuc
'     Output a row for a succesfull backup event to fStream.
'
Sub outputLineSuc(serverName As String, items() As String, fStream, dex)
    Dim hTxt As String
    Dim desc As String
    Dim bd As String
    
    bd = items(kBkupDate) & " " & items(kBkupTime)
    hTxt = getRow(dex)
    addTD hTxt, toLog(serverName, bd, FormatTimeStamp(CDate(bd)), "View Log"), "BR_BKUP_DATE"
    
    ' Example successful event format:
    ' Joe's PC (C:) to StorageSet[012] via ScriptName stored 1457 files (34.2 GB) using Normal backup
    desc = items(kMachineName)
    If (items(kSubVolParent) <> "" And UBound(items) = kMaxColumns) Then
        desc = desc & " (" & items(kSubVolParent) & "/" & items(kSourceName) & ")"
    ElseIf (items(kSourceName) <> "") Then
        desc = desc & " (" & items(kSourceName) & ")"
    End If
    desc = desc & kToStr & items(kBkupSetName)
    If (items(kScriptName) <> "") Then
        desc = desc & kViaStr & items(kScriptName)
    End If
    desc = desc & kStoredStr & items(kNumFilesCopied) & kFilesStr & _
        FormatKBytes(items(kKBStored)) & kUsingStr & items(kAction) & kBackupStr
    
    addTD hTxt, desc, "BR_SUC_DESCRIPTION"
    
    hTxt = hTxt & "</tr>" & vbCrLf
    fStream.Write (hTxt)
End Sub

' outputLineErr
'     Output a row for a failed backup event to fStream.
'
Sub outputLineErr(serverName As String, items() As String, fStream, dex)
    Dim hTxt As String
    Dim desc As String
    Dim bd As String
    
    bd = items(kBkupDate) & " " & items(kBkupTime)
    hTxt = getRow(dex)
    addTD hTxt, toLog(serverName, bd, FormatTimeStamp(CDate(bd)), "View Log"), "BR_BKUP_DATE"
    
    ' Example failed format (three lines)
    ' 519 (network communication failed)
    ' Joe's PC (C:) to StorageSet[012] via ScriptName
    ' 1457 files (34.2 GB) were stored using Normal backup with 23 other errors
    
    ' line 1
    desc = items(kFatalErr) & " (" & items(kErrName) & ")<br>" & vbCrLf
    
    ' line 2
    desc = desc & items(kMachineName)
    If (items(kSubVolParent) <> "" And UBound(items) = kMaxColumns) Then
        desc = desc & " (" & items(kSubVolParent) & "/" & items(kSourceName) & ")"
    ElseIf (items(kSourceName) <> "") Then
        desc = desc & " (" & items(kSourceName) & ")"
    End If
    desc = desc & kToStr & items(kBkupSetName)
    If (items(kScriptName) <> "") Then
        desc = desc & kViaStr & items(kScriptName)
    End If
    desc = desc & "<br>" & vbCrLf
    
    'line 3
    desc = desc & items(kNumFilesCopied) & kFilesStr & _
        FormatKBytes(items(kKBStored)) & kWereStoredUsingStr & items(kAction) & _
        kBackupWithStr & items(kNonFatalErrs) & kOtherErrorsStr
        
    addTD hTxt, desc, "BR_ERR_DESCRIPTION"
    
    hTxt = hTxt & "</tr>" & vbCrLf
    fStream.Write (hTxt)
End Sub

' outputLineNvr
'     Output a row for a backup event to the open file, fStream
'
Sub outputLineNvr(items() As String, fStream, dex)
    Dim hTxt As String
    Dim itemTxt As String
    
    hTxt = getRow(dex)
    itemTxt = items(kMachineName) & " ("
    itemTxt = itemTxt & items(kSourceName) & ")"
    addTD hTxt, itemTxt, "BR_NEVER_BACKED_UP"
    
    hTxt = hTxt & "</tr>" & vbCrLf
    fStream.Write (hTxt)
End Sub

' outputFootRep
'     Output a footer for the individual server reports. This uses the user-
' specified field from the "Edit HTML..." dialog.
'
Sub outputFootRep(serverName As String, fStream)
    Dim hTxt As String
    
    hTxt = hTxt & vbCrLf & "</table>" & vbCrLf
    addNavLinks hTxt, kReport, serverName
    hTxt = hTxt & vbCrLf & gData.rep.foot
    fStream.Write (hTxt)
End Sub

' outputFootSuc
'     Output a footer for the successful server reports. This uses the user-
' specified field from the "Edit HTML..." dialog.
'
Sub outputFootSuc(serverName As String, fStream)
    Dim hTxt As String
    
    hTxt = hTxt & vbCrLf & "</table>" & vbCrLf
    addNavLinks hTxt, kSuccess, serverName
    hTxt = hTxt & vbCrLf & gData.suc.foot
    fStream.Write (hTxt)
End Sub

' outputFootErr
'     Output a footer for the failed server reports. This uses the user-
' specified field from the "Edit HTML..." dialog.
'
Sub outputFootErr(serverName As String, fStream)
    Dim hTxt As String
    
    hTxt = hTxt & vbCrLf & "</table>" & vbCrLf
    addNavLinks hTxt, kError, serverName
    hTxt = hTxt & vbCrLf & gData.err.foot
    fStream.Write (hTxt)
End Sub

' outputFootNvr
'     Output a footer for the "Never" server reports. This uses the user-
' specified field from the "Edit HTML..." dialog.
'
Sub outputFootNvr(serverName As String, fStream)
    Dim hTxt As String
    
    hTxt = hTxt & vbCrLf & "</table>" & vbCrLf
    addNavLinks hTxt, kNever, serverName
    hTxt = hTxt & vbCrLf & gData.nvr.foot
    fStream.Write (hTxt)
End Sub


'
' ExportLogFile
'
'     Save an operations log as an HTML file.
'

Sub ExportLogFile(logFilePath, htmlFilePath, serverName As String)
    Dim fs, srcF, destF, t
    Dim htmlHeader As String, htmlFooter As String
    
    htmlHeader = "<html><head><title>" & kLogTitle & "</title></head><body><h1>" & kLogTitle & " - " & serverName & "</h1>"
    addNavLinks htmlHeader, kLog, serverName
    htmlHeader = htmlHeader & "<pre>"
    htmlFooter = "</pre>"
    addNavLinks htmlFooter, kLog, serverName
    htmlFooter = htmlFooter & "</body></html>"
    
    Set fs = CreateObject("Scripting.FileSystemObject")
    Set srcF = fs.OpenTextFile(logFilePath, 1, True, 0)                 ' Open as ANSI
    Set destF = fs.CreateTextFile(htmlFilePath, True, False)

    destF.Write htmlHeader
    Do Until (srcF.AtEndOfStream)
        t = srcF.ReadLine
    
        ' Replace all timestamps with a html version
        t = ReplaceTimeStamps(t)
        
        ' Replace easy glyphco with the html equivalent
        t = Replace(t, "$[01]", "<u>")
        t = Replace(t, "$[02]", "</u>")
        t = Replace(t, "$[03]", "<i>")
        t = Replace(t, "$[04]", "</i>")
        t = Replace(t, "$[05]", "<b>")
        t = Replace(t, "$[06]", "</b>")
        t = Replace(t, "$[07]", "<b>")
        t = Replace(t, "$[08]", "</b>")
        t = Replace(t, "$[09]", "<b>")
        t = Replace(t, "$[10]", "</b>")
        t = Replace(t, "$[11]", "<b>")
        t = Replace(t, "$[12]", "</b>")
        t = Replace(t, "$[13]", "<font color=grey>")
        t = Replace(t, "$[14]", "</font>")
        t = Replace(t, "$[15]", "<b>")
        t = Replace(t, "$[16]", "</b>")
        t = Replace(t, "$[17]", "<u>")
        t = Replace(t, "$[18]", "</u>")
        
        'Single digit versions
        t = Replace(t, "$[1]", "<u>")
        t = Replace(t, "$[2]", "</u>")
        t = Replace(t, "$[3]", "<i>")
        t = Replace(t, "$[4]", "</i>")
        t = Replace(t, "$[5]", "<b>")
        t = Replace(t, "$[6]", "</b>")
        t = Replace(t, "$[7]", "<b>")
        t = Replace(t, "$[8]", "</b>")
        t = Replace(t, "$[9]", "<b>")
        
        ' The error icon is a red '>'
        If (InStr(1, t, "$[*20750]") > 0) Then
            t = t
        End If
        
        t = Replace(t, "$[*20750]", "<font color=red><b>></b></font>")
        t = StripGlyphco(t)                             ' Remove the rest
        destF.WriteLine t
    Loop
    
    destF.Write htmlFooter
    destF.Close
    srcF.Close
End Sub

'
' StripGlyphco
'
'     Strip all $[...] text from txt.
'

Function StripGlyphco(txt)
    Dim ndx As Integer
    Dim endx As Integer
    Dim glyph As String
        
    ndx = InStr(1, txt, "$[")
    While (ndx > 0)
        endx = InStr(ndx, txt, "]")
        glyph = Mid(txt, ndx + 2, endx - ndx - 2)
        txt = Replace(txt, "$[" & glyph & "]", "")
        ndx = InStr(ndx, txt, "$[")
    Wend
    StripGlyphco = txt
End Function


' FormatTimeStamp
'
'     Format a date as a html tag. 5/21/2002 5:26:20 PM -> 5-21-2002_5-26-20_PM
'

Function FormatTimeStamp(d As Date)
    Dim stmp As String
    Dim secs As Double
    
    ' Backup Reports round up so adjust date before making time stamp
    secs = DatePart("s", d)
    secs = 60# - secs
    d = DateAdd("s", secs, d)
    
    stmp = FormatDateTime(d, 0)
    stmp = Replace(stmp, " ", "_")
    stmp = Replace(stmp, ":", "-")
    stmp = Replace(stmp, "/", "-")
    FormatTimeStamp = stmp
End Function


'
' ReplaceTimeStamps
'
'     Replace strings of the format $[xxx...xxx], where 12345678 is a date in the
' File system format, with an HTML tag for the date.
'
'     e.g. "$[126664755802200000]" (#5/21/2002 5:26:20 PM#) is converted to
' "<a name='5-21-2002_5-26-20_PM'>"
'

Function ReplaceTimeStamps(txt)
    Dim ndx As Integer
    Dim endx As Integer
    Dim fsdate As String
    Dim stmp As String
    Dim dateTest As Double
    
    dateTest = VBDateToFSTime(#1/1/1984#)
    ndx = InStr(1, txt, "$[")
    While (ndx > 0)
        endx = InStr(ndx, txt, "]")
        fsdate = Mid(txt, ndx + 2, endx - ndx - 2)
        If (IsNumeric(fsdate)) Then
            If (dateTest < CDbl(fsdate)) Then
                ' convert it to a VB date, replace spaces with underscores
                stmp = FormatTimeStamp(FSTimeToVBDate(fsdate))
                
                ' replace the match with our new time stamp
                stmp = "<a name='" & stmp & "'>"
                txt = Replace(txt, "$[" & fsdate & "]", stmp)
            End If
        End If
        ndx = InStr(endx, txt, "$[")
    Wend
    ReplaceTimeStamps = txt
End Function


'
' FSTimeToVBDate
'
'     Filesystem time is a 64 bit number equal to the number of 100 nanoseconds
' since 1/1/1601. A VB date is the number of days since 12/30/1899. The
' fraction is the part of the day from 12:00 AM (where 12:00 PM is .5).
' Note that as the resolution of Filesystem time is greater than a VB date,
' VBDateToFSTime(FSTimeToVBDate(fstime) != fstime but
' FSTimeToVBDate(VBDateToFSTime(vbd) == vbd
'

Function FSTimeToVBDate(fstime)
    ' First turn fstime to seconds since 1/1/1601
    Dim t As Double
    Dim d As Date
    Dim ndx As Integer
    
    t = CDbl(fstime)
    t = t / 10000000                        ' Convert to 100 nanoseconds
    t = t / 10                              ' VB's DateAdd complains about large doubles...
    d = #1/1/1601#                          ' ... so break up the adding into a loop of ten
    For ndx = 1 To 10
        d = DateAdd("s", t, d)
    Next
    FSTimeToVBDate = d
End Function


'
' VBDateToFSTime
'
'     Filesystem time is a 64 bit number equal to the number of 100 nanoseconds
' since 1/1/1601. A VB date is the number of days since 12/30/1899. The
' fraction is the part of the day from 12:00 AM (where 12:00 PM is .5).
'

Function VBDateToFSTime(vbd)
    Dim d As Date
    Dim secs
    d = CDate(vbd)
    secs = DateDiff("s", #1/1/1601#, d)
    VBDateToFSTime = secs * 10000000
End Function


' processOneReport
'     Create the html files for a single exported backup report. Return the
' summary info for this report in sumInfo.
'
'     Each line from fileSpec is a unique Source/Script/destination.
' Lines with no backup date are not in any script and are ignored
'
Private Sub processOneReport(fileSpec, sumInfo As SummaryInfo)
    Dim fs, fStream
    Dim destPath, repDestName, sucDestName, errDestName, nvrDestName
    Dim repStream, sucStream, errStream, nvrStream
    Dim tempTxt As String
    Dim bkupDateStr As String
    Dim bkupDate As Date
    Dim numBkups As Long
    Dim numFails As Long
    Dim fatalErrNum As Long
    Dim kbStored As Long, filesTrans As Long
    Dim bkupCmt As String
    Dim failCmt As String
    Dim oldBkup As Date, recentBkup As Date, nowDate As Date
    Dim itdex, sucdex, faildex, nvrdex As Long
    Dim items() As String
    Dim noRepEvents As Boolean, noSucEvents As Boolean, noErrEvents As Boolean
    
    Dim allLines As Variant
    Dim lineNo As Integer
    
    Const kReadOnly = 1
    Const kWrite = 2
    Const kOpenAsUnicode = -2
    Const kOpenAsANSI = 0
    
    Set fs = CreateObject("Scripting.FileSystemObject")
    Set fStream = fs.OpenTextFile(fileSpec, kReadOnly, False, kOpenAsUnicode)
    destPath = GetDestParent()
    repDestName = destPath & encodeURL(sumInfo.serverName & repSuffix)
    sucDestName = destPath & encodeURL(sumInfo.serverName & sucSuffix)
    errDestName = destPath & encodeURL(sumInfo.serverName & errSuffix)
    nvrDestName = destPath & encodeURL(sumInfo.serverName & nvrSuffix)
    
    On Error GoTo CANT_CREATE_REP_FILE
    Set repStream = fs.CreateTextFile(repDestName)
    On Error GoTo CANT_CREATE_SUC_FILE
    Set sucStream = fs.CreateTextFile(sucDestName)
    On Error GoTo CANT_CREATE_ERR_FILE
    Set errStream = fs.CreateTextFile(errDestName)
    On Error GoTo CANT_CREATE_NVR_FILE
    Set nvrStream = fs.CreateTextFile(nvrDestName)
    On Error GoTo 0
    
    outputHeadRep sumInfo.serverName, repStream
    outputHeadSuc sumInfo.serverName, sucStream
    outputHeadErr sumInfo.serverName, errStream
    outputHeadNvr sumInfo.serverName, nvrStream
    filesTrans = 0
    kbStored = 0
    nowDate = Now
    oldBkup = nowDate
    recentBkup = kImpossibleDate
    failCmt = ""
    itdex = 1
    sucdex = 1
    faildex = 1
    nvrdex = 1
    numFails = 0
    noRepEvents = True
    noSucEvents = True
    noErrEvents = True
    
    On Error Resume Next
    tempTxt = ""
    tempTxt = fStream.ReadAll
    allLines = Split(tempTxt, vbCrLf, -1)
    If (UBound(allLines) = 0) Then allLines = Split(tempTxt, vbCr, -1)
      
    On Error GoTo IGNORE
    For lineNo = LBound(allLines) + 1 To UBound(allLines)   ' Skip over first line of column labels
        items = Split(allLines(lineNo), vbTab, -1)
        bkupDateStr = items(kBkupDate) & " " & items(kBkupTime)
        If (items(kBkupDate) <> "") Then                    ' volume has been backed up
            noRepEvents = False
            outputLineRep sumInfo.serverName, items, repStream, itdex
            bkupDate = bkupDateStr
            fatalErrNum = Val(items(kFatalErr))
            If (fatalErrNum = 0) Then
                noSucEvents = False
                outputLineSuc sumInfo.serverName, items, sucStream, sucdex
                numBkups = numBkups + 1
                kbStored = kbStored + Val(items(kKBStored))
                filesTrans = filesTrans + Val(items(kNumFilesCopied))
                If (bkupDate < oldBkup) Then
                    oldBkup = bkupDate
                End If
                If (bkupDate > recentBkup) Then
                    recentBkup = bkupDate
                End If
                sucdex = sucdex + 1
            Else
                numFails = numFails + 1
                failCmt = items(kFatalErr) & " (" & items(kErrName) & ")"
                noErrEvents = False
                outputLineErr sumInfo.serverName, items, errStream, faildex
                faildex = faildex + 1
            End If
            itdex = itdex + 1
        Else                                                ' volume never backed up
            outputLineNvr items, nvrStream, nvrdex
            nvrdex = nvrdex + 1
        End If
        GoTo CONTINUE:
IGNORE:
        Resume CONTINUE:
CONTINUE:
        ' Continue if any error occurs
    Next lineNo
    
    On Error GoTo 0
    
    fStream.Close
    
    If (noRepEvents) Then
        repStream.Write "<tr>" + vbCrLf + _
            "<td colspan=" + FormatNumber(kMaxColumns, 0) + ">" + kNoBackupEventsLoggedStr + _
            sumInfo.serverName + ".</td>" + vbCrLf + _
            "</tr>" + vbCrLf + _
            "<tr>" + vbCrLf + _
            "<td colspan=" + FormatNumber(kMaxColumns, 0) + "><hr></td>" + vbCrLf + _
            "</tr>" + vbCrLf
    End If
    outputFootRep sumInfo.serverName, repStream
    repStream.Close
    
    If (noSucEvents) Then
        sucStream.Write "<tr>" + vbCrLf + _
            "<td colspan=3>" + kNoSucBackupEventsLoggedStr + _
            sumInfo.serverName + ".</td>" + vbCrLf + _
            "</tr>" + vbCrLf + _
            "<tr>" + vbCrLf + _
            "<td colspan=3><hr></td>" + vbCrLf + _
            "</tr>" + vbCrLf
    End If
    outputFootSuc sumInfo.serverName, sucStream
    sucStream.Close
    
    If (noErrEvents) Then
        errStream.Write "<tr>" + vbCrLf + _
            "<td colspan=3>" + kNoFailedBackupEventsLoggedStr + _
            sumInfo.serverName + ".</td>" + vbCrLf + _
            "</tr>" + vbCrLf + _
            "<tr>" + vbCrLf + _
            "<td colspan=3><hr></td>" + vbCrLf + _
            "</tr>" + vbCrLf
    End If
    outputFootErr sumInfo.serverName, errStream
    errStream.Close
    
    If (nvrdex = 1) Then
        nvrStream.Write "<tr>" + vbCrLf + _
            "<td colspan=1>" + kAllVolumesForStr + _
            sumInfo.serverName + kBackedUpAtLeastOnceStr + "</td>" + vbCrLf + _
            "</tr>" + vbCrLf + _
            "<tr>" + vbCrLf + _
            "<td colspan=1><hr></td>" + vbCrLf + _
            "</tr>" + vbCrLf
    End If
    outputFootNvr sumInfo.serverName, nvrStream
    nvrStream.Close
    
    bkupCmt = "" & filesTrans & kFilesStr & FormatKBytes(kbStored) & kParenStoredStr
    
    sumInfo.numBkups = numBkups
    sumInfo.numFails = numFails
    sumInfo.numNever = nvrdex - 1
    If oldBkup = nowDate Then
        sumInfo.oldBkup = kImpossibleDate
    Else
        sumInfo.oldBkup = oldBkup
    End If
    sumInfo.recentBkup = recentBkup
    sumInfo.bkupCmt = bkupCmt
    If (numFails = 0) Then
        sumInfo.failCmt = kNoErrorsForStr & sumInfo.serverName
    ElseIf (numFails = 1) Then
        sumInfo.failCmt = failCmt
    Else
        sumInfo.failCmt = kShowsErrorsForStr & sumInfo.serverName
    End If
    sumInfo.repDestName = repDestName
    sumInfo.sucDestName = sucDestName
    sumInfo.failDestName = errDestName
    
    Exit Sub
    
' If we can't create an html file, tell the user.
CANT_CREATE_REP_FILE:
    tempTxt = repDestName
CANT_CREATE_SUC_FILE:
    tempTxt = sucDestName
CANT_CREATE_ERR_FILE:
    tempTxt = errDestName
CANT_CREATE_NVR_FILE:
    tempTxt = nvrDestName
    
    If tempTxt = gData.destPath Then
        MsgBox kSorrySameNameStr & vbCrLf & _
            tempTxt & vbCrLf & kPleaseChooseDiffNameStr & _
            cmdChooseDest(1), vbInformation, kReportWatcherErrorStr
    Else
        MsgBox kSorryCantCreateStr & tempTxt & "'.", vbExclamation, kReportWatcherErrorStr
    End If
End Sub

' summarizeOneReport
'     Create the summary html for the exported backup report.
'
Function summarizeOneReport(fileSpec, fndx) As String
    Dim txt As String
    Dim serverName As String
    Dim lastDate As String
    Dim sumInfo As SummaryInfo
    Dim logFilePath As String
    Dim destLogPath As String
    
    ' Get statistics and make summary for this file
    serverName = fileSpec.Name
    serverName = left(serverName, Len(serverName) - 4)
    sumInfo.serverName = serverName
    processOneReport fileSpec, sumInfo
    
    ' Export Log file
    logFilePath = left(fileSpec.Path, Len(fileSpec.Path) - 3) & "log"
    destLogPath = GetDestParent() & encodeURL(serverName & logSuffix)
    ExportLogFile logFilePath, destLogPath, serverName

    ' Setup the row tag
    summarizeOneReport = getRow(fndx)
    
    ' Name of machine (from file name)
    addTD summarizeOneReport, toRep(serverName, serverName), "BR_SERVER_NAME"
    
    ' Last modified date and time (use BR_NOTE and BR_WARN class for style sheets)
    If (sumInfo.recentBkup = kImpossibleDate) Then
        lastDate = kNeverStr
    Else
        lastDate = FormatDateTime(sumInfo.recentBkup)
    End If
    If (Overdue(sumInfo.recentBkup, gData.warnInterval) = True) Then
        addTD summarizeOneReport, gData.warnHTML, "BR_WARN"
        addTD summarizeOneReport, lastDate, "BR_WARN"
    ElseIf (Overdue(sumInfo.recentBkup, gData.noteInterval) = True) Then
        addTD summarizeOneReport, gData.noteHTML, "BR_NOTE"
        addTD summarizeOneReport, lastDate, "BR_NOTE"
    Else
        addTD summarizeOneReport, "", "BR_NEWEST"
        addTD summarizeOneReport, lastDate, "BR_NEWEST"
    End If
    
    ' Oldest backup
    If sumInfo.oldBkup = kImpossibleDate Then
        addTD summarizeOneReport, kNAStr, "BR_OLDEST"
    Else
        addTD summarizeOneReport, FormatDateTime(sumInfo.oldBkup), "BR_OLDEST"
    End If
    
    ' Num successful backups
    addTD summarizeOneReport, toSuc(serverName, FormatNumber(sumInfo.numBkups, 0), sumInfo.bkupCmt), "BR_NUM_SUCCESS"

    ' Num failed backups
    addTD summarizeOneReport, toErr(serverName, FormatNumber(sumInfo.numFails, 0), sumInfo.failCmt), "BR_NUM_FAILED"
    
    ' Num volumes never backed up
    addTD summarizeOneReport, toNvr(serverName, FormatNumber(sumInfo.numNever, 0)), "BR_NUM_NEVER"
    
    ' Log
    addTD summarizeOneReport, toLog(serverName, kLogIcon), "BR_LOG"
     
    ' Finish row tag
    summarizeOneReport = summarizeOneReport & vbCrLf & _
        "</tr>"
End Function

' CreateHTMLFiles
'     Create the summary file and all the related files for a group of exported
' backup reports. This is the main function and calls summarizeOneReport above
' for each file in the Sources directory that ends in ".utx".
'
Sub CreateHTMLFiles()
    Dim fs, f, fc, f1, s, destFile
    Dim reportText As String
    Dim fndx, Freq As Long
    Dim savedPointer
    
    If gData.srcPath = "" Then
        lblStatus = kPleaseSelectSrcDirStr
        Exit Sub
    ElseIf gData.destPath = "" Then
        lblStatus = kPleaseSelectSrcDirStr
        Exit Sub
    Else
        lblStatus = kCreatingNewSummaryStr
    End If
    
    Set fs = CreateObject("Scripting.FileSystemObject")
    If Not (fs.FolderExists(gData.srcPath)) Then
        lblStatus = kTheSrcDirStr & gData.srcPath & kDoesNotExistStr
       ' lblStatus.ForeColor = &HFF                                         ' Red
       ' lblStatus.FontBold = True
        Exit Sub
    End If
    
    On Error Resume Next
    Set destFile = fs.CreateTextFile(gData.destPath, True)
    On Error GoTo 0
    
    If IsEmpty(destFile) Then
        lblStatus = """" & gData.destPath & "" + kCouldNotBeCreatedStr & vbCrLf & _
            kDirDoesNotExistStr
        lblStatus.ForeColor = &HC0                                  ' Red
        lblStatus.FontBold = True
        Exit Sub
    End If
    
    savedPointer = Me.MousePointer
    Me.MousePointer = vbHourglass
    
    lblStatus.ForeColor = &H80000012
    lblStatus.FontBold = False
    lblStatus = kCreatingReportStr
    
  ' Bugfix - due to problems refreshing after 15 minutes, we need to set a 15 minute max
    Freq = gData.updateFreq
    If Freq > 15 Then
        Freq = 15
    End If
    reportText = gData.sum.head & vbCrLf
    reportText = Replace(reportText, "%%updateFreq%%", FormatNumber(60 * Freq, 0, 0, 0, Tristate.TristateFalse), 1, -1, vbTextCompare)
    reportText = Replace(reportText, "%%summaryURL%%", GetFileName(gData.destPath), 1, -1, vbTextCompare)
    reportText = reportText & _
        "<table class=""BR"">" & vbCrLf

    reportText = reportText & vbCrLf & _
        getRow(0) & _
        "<th class=""BR_SERVER"">" + kServerHtmlStr & vbCrLf & _
        "<th class=""BR_NEWEST"" colspan=2>" + kMostRecentBackupHtmlStr & vbCrLf & _
        "<th class=""BR_OLDEST"">" + kOldestBackupHtmlStr & vbCrLf & _
        "<th class=""BR_NUM_SUCCESS"">" + kSuccessfulBackupsHtmlStr & vbCrLf & _
        "<th class=""BR_NUM_FAILED"">" + kFailedBackupsHtmlStr & vbCrLf & _
        "<th class=""BR_NUM_NEVER"">" + kNeverBackedUpHtmlStr & vbCrLf & _
        "<th class=""BR_LOG"">" + kLogStr & vbCrLf & _
        "</tr>"
        
    Set f = fs.GetFolder(gData.srcPath)
    Set fc = f.Files
    fndx = 1
    For Each f1 In fc
        If (Right(f1.Name, 4) = ".utx") Then
            If (f1.DateLastModified > gLastMod) Then
                gLastMod = f1.DateLastModified
            End If
            reportText = reportText & summarizeOneReport(f1, fndx) & vbCrLf
            fndx = fndx + 1
        End If
    Next
    
    reportText = reportText & vbCrLf & "</table>"
    reportText = reportText & gData.sum.foot
    
    destFile.Write (reportText)
    destFile.Close
    
    lblStatus.ForeColor = &H80000012
    lblStatus.FontBold = False
    lblStatus = kLastReportStr & Now
    
    Me.MousePointer = savedPointer
End Sub

' GetOptionDefault
'     Return the default for the specified OptionDataTypes. These are stored in
' the "Tag" field of the form objects. As Tags cannot have returns, we replace
' the string "\r" with returns before continuing.
'
Function GetOptionDefault(optionType As OptionDataTypes) As String
    Select Case (optionType)
    Case kUpdateFreq:
        GetOptionDefault = Replace(frmOptions.txtUpdateFreq.Tag, "\r", vbCrLf)
    Case kNoteInterval:
        GetOptionDefault = Replace(frmOptions.txtNoteInterval.Tag, "\r", vbCrLf)
    Case kNoteHTML:
        GetOptionDefault = Replace(frmOptions.txtNoteHTML.Tag, "\r", vbCrLf)
    Case kWarnInterval:
        GetOptionDefault = Replace(frmOptions.txtWarnInterval.Tag, "\r", vbCrLf)
    Case kWarnHTML:
        GetOptionDefault = Replace(frmOptions.txtWarnHTML.Tag, "\r", vbCrLf)
    Case Else
        GetOptionDefault = ""
    End Select
End Function

' GetOptionData
'     Return the current value for our main options. This function is needed by
' the other forms as they cannot access another forms globals.
'
Function GetOptionData(optionType As OptionDataTypes) As String
    Select Case (optionType)
    Case kUpdateFreq:
        GetOptionData = gData.updateFreq
    Case kNoteInterval:
        GetOptionData = gData.noteInterval
    Case kNoteHTML:
        GetOptionData = gData.noteHTML
    Case kWarnInterval:
        GetOptionData = gData.warnInterval
    Case kWarnHTML:
        GetOptionData = gData.warnHTML
    Case Else
        GetOptionData = ""
    End Select
End Function

' GetHTMLDefault
'     Return the default value for an HTML section and type.
'
Function GetHTMLDefault(reportType As ReportTypes, Section As SectionTypes) As String
    Select Case (reportType)
    Case kSummary:
        If (Section = kHead) Then
            GetHTMLDefault = Replace(frmHTML.txtSumHead.Tag, "\r", vbCrLf)
        Else
            GetHTMLDefault = Replace(frmHTML.txtSumFoot.Tag, "\r", vbCrLf)
        End If
    Case kReport:
        If (Section = kHead) Then
            GetHTMLDefault = Replace(frmHTML.txtRepHead.Tag, "\r", vbCrLf)
        Else
            GetHTMLDefault = Replace(frmHTML.txtRepFoot.Tag, "\r", vbCrLf)
        End If
    Case kSuccess:
        If (Section = kHead) Then
            GetHTMLDefault = Replace(frmHTML.txtSucHead.Tag, "\r", vbCrLf)
        Else
            GetHTMLDefault = Replace(frmHTML.txtSucFoot.Tag, "\r", vbCrLf)
        End If
    Case kError:
        If (Section = kHead) Then
            GetHTMLDefault = Replace(frmHTML.txtErrHead.Tag, "\r", vbCrLf)
        Else
            GetHTMLDefault = Replace(frmHTML.txtErrFoot.Tag, "\r", vbCrLf)
        End If
    Case kNever:
        If (Section = kHead) Then
            GetHTMLDefault = Replace(frmHTML.txtNvrHead.Tag, "\r", vbCrLf)
        Else
            GetHTMLDefault = Replace(frmHTML.txtNvrFoot.Tag, "\r", vbCrLf)
        End If
    Case Else
        GetHTMLDefault = ""
    End Select
End Function

' GetHTMLData
'     Return the html for the specified section and type from our globals.
' This is used by the frmHTML form to access our globals.
'
Function GetHTMLData(reportType As ReportTypes, Section As SectionTypes) As String
    Dim hData As HtmlData
    Select Case (reportType)
    Case kSummary:
        hData = gData.sum
    Case kReport:
        hData = gData.rep
    Case kSuccess:
        hData = gData.suc
    Case kError:
        hData = gData.err
    Case kNever:
        hData = gData.nvr
    Case Else
        GetHTMLData = ""
        Exit Function
    End Select
    
    Select Case (Section)
    Case kHead:
        GetHTMLData = hData.head
    Case kFoot:
        GetHTMLData = hData.foot
    Case Else
        GetHTMLData = ""
    End Select
End Function


' InitDataFromForm
'     Load our global data from the form's fields.
'
Public Sub InitDataFromForm()
    Dim s As String
    
    gData.srcPath = lblSrc
    gData.destPath = lblDest
    gData.updateFreq = frmOptions.txtUpdateFreq
    gData.noteInterval = frmOptions.txtNoteInterval
    gData.warnInterval = frmOptions.txtWarnInterval
    gData.noteHTML = frmOptions.txtNoteHTML
    gData.warnHTML = frmOptions.txtWarnHTML
    
    gData.sum.head = frmHTML.txtSumHead
    gData.sum.foot = frmHTML.txtSumFoot
    
    gData.rep.head = frmHTML.txtRepHead
    gData.rep.foot = frmHTML.txtRepFoot
    
    gData.suc.head = frmHTML.txtSucHead
    gData.suc.foot = frmHTML.txtSucFoot
    
    gData.err.head = frmHTML.txtErrHead
    gData.err.foot = frmHTML.txtErrFoot
    
    gData.nvr.head = frmHTML.txtNvrHead
    gData.nvr.foot = frmHTML.txtNvrFoot
    
    gLastMod = 0                               ' To cause a new summary to be generated
End Sub

' InitOptionsForm
'     Init the "ReportWatcher Options" form fields from the global data.
'
Public Sub InitOptionsForm()
    frmOptions.txtUpdateFreq = gData.updateFreq
    frmOptions.txtNoteInterval = gData.noteInterval
    frmOptions.txtWarnInterval = gData.warnInterval
    frmOptions.txtNoteHTML = gData.noteHTML
    frmOptions.txtWarnHTML = gData.warnHTML
End Sub

' InitHTMLForm
'     Init ReportWatcher's "Edit HTML" form's fields from the global data.
'
Public Sub InitHTMLForm()
    frmHTML.txtRepHead = gData.rep.head
    frmHTML.txtRepFoot = gData.rep.foot
    
    frmHTML.txtSumHead = gData.sum.head
    frmHTML.txtSumFoot = gData.sum.foot
    
    frmHTML.txtSucHead = gData.suc.head
    frmHTML.txtSucFoot = gData.suc.foot
    
    frmHTML.txtErrHead = gData.err.head
    frmHTML.txtErrFoot = gData.err.foot
    
    frmHTML.txtNvrHead = gData.nvr.head
    frmHTML.txtNvrFoot = gData.nvr.foot
End Sub

' RevertForm
'     Used to revert the Options and Edit HTML forms to the current state.
'
Public Sub RevertForm()
    InitOptionsForm
    InitHTMLForm
End Sub

' UseDefaultFromGen
'     Implement the "Use Default..." button on the Options form.
'
Public Sub UseDefaultFromGen()
    frmOptions.txtUpdateFreq = GetOptionDefault(kUpdateFreq)
    frmOptions.txtNoteInterval = GetOptionDefault(kNoteInterval)
    frmOptions.txtWarnInterval = GetOptionDefault(kWarnInterval)
    frmOptions.txtNoteHTML = GetOptionDefault(kNoteHTML)
    frmOptions.txtWarnHTML = GetOptionDefault(kWarnHTML)
End Sub

' UseDefaultFromSum
'     Implement the "Use Default..." button on the Summary section of the
' "Edit HTML" form.
'
Public Sub UseDefaultFromSum()
    frmHTML.txtSumHead = Replace(frmHTML.txtSumHead.Tag, "\r", vbCrLf)
    frmHTML.txtSumFoot = Replace(frmHTML.txtSumFoot.Tag, "\r", vbCrLf)
End Sub

' UseDefaultFromRep
'     Implement the "Use Default..." button on the Reports section of the
' "Edit HTML" form.
'
Public Sub UseDefaultFromRep()
    frmHTML.txtRepHead = Replace(frmHTML.txtRepHead.Tag, "\r", vbCrLf)
    frmHTML.txtRepFoot = Replace(frmHTML.txtRepFoot.Tag, "\r", vbCrLf)
End Sub

' UseDefaultFromSuc
'     Implement the "Use Default..." button on the successful section of the
' "Edit HTML" form.
'
Public Sub UseDefaultFromSuc()
    frmHTML.txtSucHead = Replace(frmHTML.txtSucHead.Tag, "\r", vbCrLf)
    frmHTML.txtSucFoot = Replace(frmHTML.txtSucFoot.Tag, "\r", vbCrLf)
End Sub

' UseDefaultFromErr
'     Implement the "Use Default..." button on the Failed section of the
' "Edit HTML" form.
'
Public Sub UseDefaultFromErr()
    frmHTML.txtErrHead = Replace(frmHTML.txtErrHead.Tag, "\r", vbCrLf)
    frmHTML.txtErrFoot = Replace(frmHTML.txtErrFoot.Tag, "\r", vbCrLf)
End Sub

' UseDefaultFromNvr
'     Implement the "Use Default..." button on the Never Backed Up section
' of the "Edit HTML" form.
'
Public Sub UseDefaultFromNvr()
    frmHTML.txtNvrHead = Replace(frmHTML.txtNvrHead.Tag, "\r", vbCrLf)
    frmHTML.txtNvrFoot = Replace(frmHTML.txtNvrFoot.Tag, "\r", vbCrLf)
End Sub

' cmdOptions_Click
'     Implement the "Options..." button
'
Private Sub cmdOptions_Click()
    frmOptions.showForm
End Sub

' cmdViewHTML_MouseMove
'
Sub cmdViewHTML_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    'System.Windows.Forms.Cursor.Current = System.Windows.Forms.Cursors.Hand
End Sub

' cmdViewHTML_Click
'     Implement the "Edit HTML..." button
'
Private Sub cmdViewHTML_Click()
    frmHTML.showForm
End Sub

' Form_Load
'     Set up our global data and forms from the registry.
'
Private Sub Form_Load()
    Const AppName As String = "Retrospect"
    Const Section As String = "ReportSummary"
    Dim savedWindCoor As Coor
    Dim screenRect As Rect
    Dim strFunction As String
    Dim strParm As String
    Dim iLen As Integer
    Dim sParams() As String
    
    ' get the command line arguments
    GetCommandLine sParams
    
    ' if user wants command line help, show the dialog
    If WantsCLHelp(sParams) Then
      ShowCLHelp
    End If
    
   
    Load frmOptions
    
    UseDefaultFromGen
    UseDefaultFromRep
    UseDefaultFromSum
    UseDefaultFromSuc
    UseDefaultFromErr
    UseDefaultFromNvr
    
    ' Get General Settings
    lblSrc = GetSettingEx(sParams, AppName, Section, "SourcePath", lblSrc, False)
    lblDest = GetSettingEx(sParams, AppName, Section, "DestPath", lblDest, False)
   
    frmOptions.txtUpdateFreq = GetSettingEx(sParams, AppName, Section, "UpdateFreq", frmOptions.txtUpdateFreq, True)
    frmOptions.txtNoteInterval = GetSettingEx(sParams, AppName, Section, "NoteInterval", frmOptions.txtNoteInterval, True)
    frmOptions.txtWarnInterval = GetSettingEx(sParams, AppName, Section, "WarnInterval", frmOptions.txtWarnInterval, True)
    
    frmOptions.txtNoteHTML = GetSetting(AppName, Section, "NoteHTML", frmOptions.txtNoteHTML)
    frmOptions.txtWarnHTML = GetSetting(AppName, Section, "WarnHTML", frmOptions.txtWarnHTML)
   
    ' Get Summary HTML settings
    frmHTML.txtSumHead = GetSetting(AppName, Section, "SumHead", frmHTML.txtSumHead)
    frmHTML.txtSumFoot = GetSetting(AppName, Section, "SumFoot", frmHTML.txtSumFoot)
    
    ' Get Report HTML settings
    frmHTML.txtRepHead = GetSetting(AppName, Section, "RepHead", frmHTML.txtRepHead)
    frmHTML.txtRepFoot = GetSetting(AppName, Section, "RepFoot", frmHTML.txtRepFoot)
    
    ' Get Success HTML settings
    frmHTML.txtSucHead = GetSetting(AppName, Section, "SucHead", frmHTML.txtSucHead)
    frmHTML.txtSucFoot = GetSetting(AppName, Section, "SucFoot", frmHTML.txtSucFoot)
    
    ' Get Error HTML settings
    frmHTML.txtErrHead = GetSetting(AppName, Section, "ErrHead", frmHTML.txtErrHead)
    frmHTML.txtErrFoot = GetSetting(AppName, Section, "ErrFoot", frmHTML.txtErrFoot)

    ' Get Error HTML settings
    frmHTML.txtNvrHead = GetSetting(AppName, Section, "NvrHead", frmHTML.txtNvrHead)
    frmHTML.txtNvrFoot = GetSetting(AppName, Section, "NvrFoot", frmHTML.txtNvrFoot)

    InitDataFromForm
    
    ' Get saved window position
    savedWindCoor.x = GetSetting(AppName, Section, "savedLeft", 850)
    savedWindCoor.y = GetSetting(AppName, Section, "savedTop", 450)
    screenRect.left = 0
    screenRect.top = 0
    screenRect.width = Screen.width
    screenRect.height = Screen.height
    PinToRect savedWindCoor, screenRect
    
    Me.Move savedWindCoor.x, savedWindCoor.y
    
    If (GetSetting(AppName, Section, "minimized", "false") = "true") Then
        Me.WindowState = vbMinimized
    End If
End Sub

' Form_Unload
'     Save our new settings and unload the Options and HTML forms.
'
Private Sub Form_Unload(Cancel As Integer)
    Const AppName As String = "Retrospect"
    Const Section As String = "ReportSummary"
    
    ' Save General Settings
    SaveSetting AppName, Section, "SourcePath", gData.srcPath
    SaveSetting AppName, Section, "DestPath", gData.destPath
    SaveSetting AppName, Section, "UpdateFreq", gData.updateFreq
    SaveSetting AppName, Section, "NoteInterval", gData.noteInterval
    SaveSetting AppName, Section, "WarnInterval", gData.warnInterval
    SaveSetting AppName, Section, "NoteHTML", gData.noteHTML
    SaveSetting AppName, Section, "WarnHTML", gData.warnHTML
    
    ' Save Summary HTML settings
    SaveSetting AppName, Section, "SumHead", gData.sum.head
    SaveSetting AppName, Section, "SumFoot", gData.sum.foot
    
    ' Save Report HTML settings
    SaveSetting AppName, Section, "RepHead", gData.rep.head
    SaveSetting AppName, Section, "RepFoot", gData.rep.foot
    
    ' Save Success HTML settings
    SaveSetting AppName, Section, "SucHead", gData.suc.head
    SaveSetting AppName, Section, "SucFoot", gData.suc.foot
    
    ' Save Error HTML settings
    SaveSetting AppName, Section, "ErrHead", gData.err.head
    SaveSetting AppName, Section, "ErrFoot", gData.err.foot
    
    ' Save Never Backed Up HTML settings
    SaveSetting AppName, Section, "NvrHead", gData.nvr.head
    SaveSetting AppName, Section, "NvrFoot", gData.nvr.foot
    
    Unload frmOptions
    Unload frmHTML
    
    ' Save window location
    If (Me.WindowState = vbMinimized) Then
        SaveSetting AppName, Section, "minimized", "true"
    Else
        SaveSetting AppName, Section, "minimized", "false"
        SaveSetting AppName, Section, "savedLeft", Me.left
        SaveSetting AppName, Section, "savedTop", Me.top
    End If
End Sub

' lblDest_Click
'     Implement the hot link action for viewing the summary html in a browser.
'
Private Sub lblDest_Click()
    StartDoc ("file:" & lblDest)
End Sub

' cmdChooseDest_Click
'     Implement the "Choose Destination..." button.
'
Private Sub cmdChooseDest_Click(Index As Integer)
    Dim newPath As String
    
    newPath = GetDestPath(kSaveSummaryFileStr, gData.destPath)
    If (newPath <> "") Then
        gData.destPath = newPath
        lblDest = newPath
        gLastMod = 0                        ' Reset so we process asap
    End If
End Sub

' cmdChooseSrc_Click
'     Implement the "Choose Source..." button
'
Private Sub cmdChooseSrc_Click(Index As Integer)
    Dim newPath As String

    newPath = GetSourcePath(kChooseAReportStr, gData.srcPath)
    If (newPath <> "") Then
        gData.srcPath = newPath
        lblSrc = newPath
        gLastMod = 0                        ' Reset so we process asap
    End If
End Sub

' tmrWatcher_Timer
'     Call CreateHTMLFiles periodically.
'
Private Sub tmrWatcher_Timer()
    Static lastUpdate
    
    lastUpdate = lastUpdate + tmrWatcher.Interval
    If (gLastMod = 0 Or lastUpdate > Val(frmOptions.txtUpdateFreq) * 1000 * 60) Then
        lastUpdate = 0
        CreateHTMLFiles
    End If
End Sub
' ShowCLHelp
'   Search command line params for either -? or /?
'
Private Function ShowCLHelp() As Boolean
  'enumerate the resulting parameters
    frmCmdLineHelp.Show vbModal
End Function
' WantsCLHelp
'   Search command line params for either -? or /?
'
Private Function WantsCLHelp(ByRef sParams() As String) As Boolean
  'enumerate the resulting parameters
    Dim iParam As Long
    Dim tempStr As String
    WantsCLHelp = False
    For iParam = LBound(sParams) To UBound(sParams)
        tempStr = sParams(iParam)
        If left(tempStr, 1) = "-" Or left(tempStr, 1) = "/" Then
             If Mid(tempStr, 2, 1) = "?" Then
                WantsCLHelp = True
                Exit Function
            End If
        End If
    Next iParam
End Function
' GetParam
'   Get a setting from the the command line
'
Private Function GetParam(ByRef sParams() As String, Key As String) As String
    Dim chrKey As String
    Dim lKey As String
    Dim iParam As Long
    Dim tempStr As String
    If Key = "SourcePath" Then
        lKey = "r"
    ElseIf Key = "DestPath" Then
        lKey = "h"
    ElseIf Key = "UpdateFreq" Then
        lKey = "u"
    ElseIf Key = "NoteInterval" Then
        lKey = "n"
    ElseIf Key = "WarnInterval" Then
        lKey = "w"
    End If
    
    'enumerate the resulting parameters
    For iParam = LBound(sParams) To UBound(sParams)
        tempStr = sParams(iParam)
        If left(tempStr, 1) = "-" Or left(tempStr, 1) = "/" Then
            chrKey = Mid(tempStr, 2, 1)
            chrKey = LCase(chrKey)
            If chrKey = lKey Then
                GetParam = Mid(tempStr, 3)
                GetParam = Replace(GetParam, ChrQuote, ChrSpace)
                GetParam = Trim(GetParam)
                Exit Function
            End If
        End If
    Next iParam
    
    GetParam = ""
End Function

' GetSetingEx
'   Get a setting from the .ini file only after first checking the command line
'
Private Function GetSettingEx(ByRef sParams() As String, AppName As String, Section As String, Key As String, default As String, numCheck As Boolean) As String
    Dim param As String
    param = GetParam(sParams, Key)
    
    ' the numeric fields must have numeric parameter values
    If numCheck And (IsNumeric(param) = False Or Len(param) > MAX_DIGITS) Then
        param = ""
    End If
    
    If param = "" Then
        If Key = "SourcePath" Then
            GetSettingEx = GetSetting(AppName, Section, Key, lblSrc)
        ElseIf Key = "DestPath" Then
            GetSettingEx = GetSetting(AppName, Section, Key, lblDest)
        ElseIf Key = "UpdateFreq" Then
            GetSettingEx = GetSetting(AppName, Section, Key, frmOptions.txtUpdateFreq)
        ElseIf Key = "NoteInterval" Then
            GetSettingEx = GetSetting(AppName, Section, Key, frmOptions.txtNoteInterval)
        ElseIf Key = "WarnInterval" Then
            GetSettingEx = GetSetting(AppName, Section, Key, frmOptions.txtWarnInterval)
        End If
    Else
        GetSettingEx = param
    End If
End Function
